
package de.ivu.elect.presentation.gruppeimgebiet;

import java.util.List;

import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSelectChangeEvent;
import de.ivu.elect.business.gruppeimgebiet.boundary.ReferendumVorlageImGebietSearchParameters;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagStatus;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.gruppeimgebiet.table.ReferendumVorlageImGebietColumnBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;
import de.ivu.elect.presentation.wahlvorschlag.WahlvorschlagSearchViewResolver;
import de.ivu.elect.presentation.wahlvorschlag.WahlvorschlagSearchViewResolverTarget;

@OnlineHilfeId(value = "784")
@Named(ReferendumVorlageImGebietSearchView.COMPONENT_NAME)
@View(viewId = ReferendumVorlageImGebietSearchView.VIEW_ID, useCase = UseCasePermission.REFERENDUM_VORLAGE_SEARCH)
public class ReferendumVorlageImGebietSearchView extends AbstractGruppeImGebietSearchView implements WahlvorschlagSearchViewResolverTarget {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "referendumVorlageImGebietSearchView";

  public static final String VIEW_ID = "/gruppeimgebiet/referendum-vorlage-im-gebiet-search.xhtml";

  @Inject
  private transient WahlvorschlagSearchViewResolver wahlvorschlagSearchViewResolver;

  @Inject
  @ConversationGroup(ReferendumVorlageImGebietSearchParameters.class)
  private transient ReferendumVorlageImGebietSearchParameters referendumVorlageImGebietSearchParameters;

  @Inject
  private transient ReferendumVorlageImGebietColumnBuilder referendumVorlageImGebietColumnBuilder;

  public ReferendumVorlageImGebietSearchView() {
    super();
  }

  @PreConditionCheck
  public String checkPreCondition() {
    return wahlvorschlagSearchViewResolver.checkCondition(VIEW_ID);
  }

  @Override
  public void preRenderView() {
    // Do nothing...
  }

  @Override
  protected AbstractGebietSecurityFilter<GruppeImGebiet> getGebietSecurityFilter() {
    return AbstractGebietSecurityFilter.createEntityMitGebietSecurityFilter(getEinsehenGebietSecurity());
  }

  @Override
  public String getGebietName() {
    return getSelectedGebietNameFormatted();
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    referendumVorlageImGebietSearchParameters.setGebiet(getSelectedGebiet());
  }

  /**
   * @deprecated To be removed...
   * @see ReferendumVorlageImGebietSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected List<GruppeImGebiet> performSearch() {
    return search.getSearchResult(referendumVorlageImGebietSearchParameters, getEagerLoadingCollector());
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    // Do nothing...
  }

  @Override
  public String getWahlvorschlagStatusOffenMessage() {
    return getMessage(WahlvorschlagStatus.OFFEN);
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLVORSCHLAG_QS_FUER_ALLE_ZULASSUNGSVORSCHLAG_SETZEN)
  public String fuerAlleZulassungsvorschlagSetzen() {
    return getViewId(); // Nicht relevant...
  }

  public void onGebietSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietSelectChangeEvent event) {
    reset();
  }

  @Override
  public EagerLoadingCollector getEagerLoadingCollector() {
    EagerLoadingCollector eagerLoadingCollector = super.getEagerLoadingCollector();
    referendumVorlageImGebietColumnBuilder.collectEagerLoadings(eagerLoadingCollector);

    return eagerLoadingCollector;
  }
}
